def add_user(name, profile, database):
    database[name]=profile
    return database

def compatibility_score(user_1, user_2, database):
    u1 = database[user_1]
    u2 = database[user_2]
    if u1['gender']!=u2['gender'] and user_1 != user_2:
        return len(u1["movies"] & u2["movies"]) + \
        len(u1["food"] & u2["food"]) + \
        len(u1["genes"] - u2["genes"]) + \
        len(u2["genes"] - u1["genes"])
    else:
        return 0
    
def most_compatible(user, database):
    max_score = 0
    bestmatch = ""
    for u2 in database.keys():
        if u2 != user:
            score = compatibility_score(user,u2,database)
            if score > max_score:
                score = max_score
                bestmatch = u2        
    return bestmatch

bob={'movies':{'A','B','Z'},
     'food':{'burger','sushi', 'poutine'},
     'genes':{'AAT','GGC','TAG'},
     'gender':'M'}

alice={'movies':{'A','C','D'},
     'food':{'burger','salad','sushi'},
     'genes':{'AAT','GGC','TAG'},
     'gender':'F'}

charlie={'movies':{'A','C','Z'},
     'food':{'burger','sushi'},
     'genes':{'AAC','GGA','TAT'},
     'gender':'M'}

lisa={'movies':{'A','B','Z'},
     'food':{'sushi','salad','poutine'},
     'genes':{'AAC','GGA','TAC'},
     'gender':'F'}

database={}

database = add_user('bob', bob, database)
database = add_user('alice', alice, database)
database = add_user('charlie', charlie, database)
database = add_user('lisa', lisa, database)

for u in database.keys():
    print(u, 'best match:', most_compatible(u, database))
    

#print(database)
